unit vtyoutubedl;

interface
uses dvcrt, dvwin, sysutils, shellapi,
    windows,
    vtmsg;

procedure atualizaYoutube_dl;

implementation

{--------------------------------------------------------}
{                   atualiza youtube-dl
{--------------------------------------------------------}

var
    Info: TShellExecuteInfo;

function ShellExecuteAndWait(Operation, FileName, Parameter, Directory: String;
                        Show: Word; bWait: Boolean): Longint;
var
    bOK: Boolean;
begin
    FillChar(Info, SizeOf(Info), Chr(0));
    Info.cbSize := SizeOf(Info);
    Info.fMask := SEE_MASK_NOCLOSEPROCESS;
    Info.lpVerb := PChar(Operation);
    Info.lpFile := PChar(FileName);
    Info.lpParameters := PChar(Parameter);
    Info.lpDirectory := PChar(Directory);
    Info.nShow := Show;
    bOK := Boolean(ShellExecuteEx(@Info));
    if bOK then
        begin
            if bWait then
                begin
                    while WaitForSingleObject(Info.hProcess, 100) = WAIT_TIMEOUT do
                    delay (100);
                    bOK := GetExitCodeProcess(Info.hProcess, DWORD(Result));
              end
          else
              Result := 0;
        end;

    if not bOK then
        Result := -1;
end;

{--------------------------------------------------------}

procedure atualizaYoutube_dl;
var
    Parametros: Pchar;
    cmdAtualiza: string;
begin
    limpaBufTec;
    exit; // Atualizao desativada no momento para no correr risco de trocar o que est funcionando.
    mensagem ('VTATUALI', 1);  {'Atualizando...'}
    cmdAtualiza := sintambiente('DOSVOX','PGMDOSVOX')+'\youtube-dl.exe '+ '-U';
    try
        Parametros := Pchar('/c ' + cmdAtualiza);
        ShellExecuteAndWait('open', 'cmd', Parametros, '', SW_HIDE, True);
    Except
        on E:Exception do
             sintBip;
    end;
end;

end.
